/*-
 * Copyright 2021 Hochschule für Technik Stuttgart
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.hft.stuttgart.ade.foodwaterenergycitygml4j.landuse.model;



import org.citygml4j.builder.copy.CopyBuilder;
import org.citygml4j.model.citygml.ade.binding.ADEModelObject;
import org.citygml4j.model.common.visitor.FeatureFunctor;
import org.citygml4j.model.common.visitor.FeatureVisitor;
import org.citygml4j.model.common.visitor.GMLFunctor;
import org.citygml4j.model.common.visitor.GMLVisitor;
import org.citygml4j.model.gml.feature.AbstractFeature;

public class FoodWaterEnergy extends AbstractFeature implements ADEModelObject {

	private static final long serialVersionUID = -3892787504021716683L;
	private String areaName;
	private String systemName;
	private ConsistsOfFWESurvey consistsOfFWESurvey;
	
	public String getAreaName() {
		return areaName;
	}
	
	public boolean isAreaName() {
		return areaName!=null;
	}

	public void setAreaName(String areaName) {
		this.areaName = areaName;
	}

	public String getSystemName() {
		return systemName;
	}
	
	public boolean isSystemName() {
		return systemName != null;
	}

	public void setSystemName(String systemName) {
		this.systemName = systemName;
	}

	public ConsistsOfFWESurvey getConsistsOfFWESurvey() {
		return consistsOfFWESurvey;
	}
	
	public boolean isConsistsOfFWESurvey() {
		return consistsOfFWESurvey!=null;
	}
	public void setConsistsOfFWESurvey(ConsistsOfFWESurvey consistsOfFWESurvey) {
		this.consistsOfFWESurvey = consistsOfFWESurvey;
	}
	@Override
	public Object copy(CopyBuilder copyBuilder) {
		return copyTo(new FoodWaterEnergy(),copyBuilder);
	}

	@Override
	public void accept(FeatureVisitor visitor) {
		visitor.visit((ADEModelObject)this);
	}

	@Override
	public <T> T accept(FeatureFunctor<T> visitor) {
		return visitor.apply((ADEModelObject)this);
	}

	@Override
	public void accept(GMLVisitor visitor) {
		visitor.visit((ADEModelObject)this);
		
	}

	@Override
	public <T> T accept(GMLFunctor<T> visitor) {
		return visitor.apply((ADEModelObject)this);
	}
}
